//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
// Customize controlP5
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
void KPCustomize(ControlP5 controlP5){
    PFont pfont = createFont("Helvetica", 12, true);
    ControlFont font = new ControlFont(pfont);
    controlP5.setControlFont(font); 
    controlP5.setColorActive(color(140));
    controlP5.setColorForeground(color(140));
    controlP5.setColorBackground(color(170));
    controlP5.setColorLabel(color(15));
    controlP5.setColorValue(color(15));
}

//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
// Class to create a controlP5 button
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
class KPButton{
    ControlGroup kpGroup;
    Button kpButton;

    // * * * Constructor * * * //
    KPButton(ControlP5 controlP5, String groupName, String buttonLabel, int x, int y, int wide, int high, boolean hide){
	kpGroup = controlP5.addGroup(groupName, x-2, y-2, wide+4);
	kpGroup.setBackgroundHeight(high+5);       
	kpGroup.setBackgroundColor(color(135));
	kpGroup.hideBar(); 
	kpButton = controlP5.addButton(buttonLabel, 0, x, y, wide, high); 
	if(hide) hide();
    }

    // * * * Constructor (default hide) * * * //
    KPButton(ControlP5 controlP5, String groupName, String buttonLabel, int x, int y, int wide, int high){
	this(controlP5, groupName, buttonLabel, x, y, wide, high, true); }

    // * * * Hide the button * * * //
    void hide(){
	kpButton.hide();
	kpGroup.hide();
    }

    // * * * Show the button * * * //
    void show(){ kpButton.show(); kpGroup.show(); }
}



//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
// Class to create a number box
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
class KPSpinBox{

    KPSpinBox(ControlP5 controlP5){
	
    }

}
