//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
// Class for a pointer
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
class Pointer {

    boolean _selected;
    color _color;
    color _selectedColor;
    float transX, transY, zoom;
    Point _locate, _origin;
    
    // * * * Constructor * * * //
    Pointer(Point locate, Point origin){
	_locate = locate;
	_selected = false;
	_color = color(71, 94, 94, 105);
	_selectedColor = color(193, 255, 255);
	_origin = origin;
    }

    // * * * Constructor (default origin) * * * //
    Pointer(Point locate) { this(locate, new Point()); }
    
    // * * * Set the selected state * * * //
    void setSelected(boolean selected) { _selected = selected; }
   
    // * * * Set/Get the location of the pointer * * * //
    void setLocate(Point locate) { _locate = locate; }
    Point getLocate() { return _locate; }
    
    void drawPointer(Point trans, Point rot) {
	
	pushMatrix();
	translate(width/2, height/2, 0);
	rotateX(radians(rot.x()));
	rotateY(radians(rot.y()));
	translate(_origin.x(), _origin.y(), _origin.z());
	translate(trans.x(), trans.y(), trans.z());
	translate(_locate.x(), _locate.y(), _locate.z());

	if(_selected){ 
	    noStroke(); fill(_color);
	    ellipse(0, 0, 16, 16);
	    noFill(); strokeWeight(2);
	    stroke(_selectedColor);	
	    ellipse(0,0, 18, 18);  
	    ellipse(0,0, 20, 20);
	}	
	else { 
	    fill(color(0,0,0,10));
	    ellipse(0, 0, 16, 16);
	    noFill(); strokeWeight(2);
	    stroke(color(55,55,55,255));
	    ellipse(0,0, 18, 18);
	    stroke(color(185,185,185,155));
	    ellipse(0,0, 20, 20);
	}
	popMatrix();
    }
}
